/**project info**
* target: Windows/DLL
* author: Kamek
* name: mircustom
* description: mIRC customizer
*/
#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "mircustom.h"

BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD fdwReason, LPVOID lpvReserved) {
	hInstance = hInstDLL;
	return TRUE;
}

void __declspec(dllexport) __stdcall LoadDll(LOADINFO* lInfo) {
	lInfo->mKeep = TRUE;
}

int __declspec(dllexport) __stdcall UnloadDll(int mTimeout) {
	//if (mTimeout == 1) { return 0; }
	return 0;
}





HWND GetTargetWindow(char* data, HWND aWnd, HWND mWnd) {
	HWND hWnd; char *newdata;
	if (strlen(data) <= 3) { hWnd = aWnd; }
	else if (!strncmp(data, "-m ", 3)) { strcpy(data, &data[3]); hWnd = mWnd; }
	else if (!strncmp(data, "-a ", 3)) { strcpy(data, &data[3]); hWnd = aWnd; }
	else if (!strncmp(data, "-w", 2)) {
		hWnd = (HWND)strtoul(&data[2], &newdata, 10);
		if (strlen(newdata) > 1) {
			if (!strncmp(newdata, " ", 1)) { newdata = &newdata[1]; }
		}
		strcpy(data, newdata);
	}
	else { hWnd = aWnd; }
	return hWnd;
}





MIRCDECLARE Titlebar(MIRCPARAMS) {
	/* use: Titlebar -amw [hwnd] <text>
					the switches are the same for SetIcon */
	HWND hWnd = GetTargetWindow(data, aWnd, mWnd);

	if (!IsWindow(hWnd)) { RetErr(ERR_INVHWND); }
	SetWindowText(hWnd, data);
	RetOK;
}

MIRCDECLARE SetIcon(MIRCPARAMS) {
	/* use: SetIcon -amw [hwnd] [index] <filename>
					-a = active window
					-m = mIRC main window
					-w = another window (specify then hwnd)
					hwnd = the window you want (use $window().hwnd or $dialog().hwnd)
					index = icon index (starting from 1)
					filename = self-explanatory
		 if you don't specify an index, 0 will be used. */
	if (strlen(data) == 0) { RetErr(ERR_INVPARAM); }
	HICON LargeIcon, SmallIcon; UINT Len, Index; DWORD Result;
	char cIndex[4], *FileName, FullName[MAX_PATH]; HWND hWnd = GetTargetWindow(data, aWnd, mWnd);

	if (!IsWindow(hWnd)) { RetErr(ERR_INVHWND); }

	Len = strcspn(data, " ,");
	if (Len == 0) { RetErr(ERR_INVPARAM); }
	else if (Len < sizeof(cIndex)) {
		memset(cIndex, '\0', sizeof(cIndex));
		strncpy(cIndex, data, Len);
		if (IsNumber(cIndex)) {
			Index = atoi(cIndex);
			if (Index > 0) { Index--; }
			FileName = &data[Len + 1];
		}
		else { Index = 0; FileName = data; }
	}
	else { Index = 0; FileName = data; }

	// look for the file in default paths...
	Result = SearchPath(NULL, FileName, NULL, sizeof(FullName), FullName, NULL);
	if (Result == 0) { RetErr(ERR_FNF); }
	else if (Result > sizeof(FullName)) { RetErr(ERR_BIGPATH); }
	else if (ExtractIconEx(FullName, Index, &LargeIcon, &SmallIcon, 1) == 0) { RetErr(ERR_NOICON); }
	// try to have both icons
	if (LargeIcon == NULL) { LargeIcon = SmallIcon; }
	else if (SmallIcon == NULL) { SmallIcon = LargeIcon; }

	SmallIcon = (HICON)SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)SmallIcon);
	LargeIcon = (HICON)SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM)LargeIcon);
	if (SmallIcon) { DestroyIcon(SmallIcon); }
	if (LargeIcon) { DestroyIcon(LargeIcon); }
	RetOK;
}

MIRCDECLARE CountIcons(MIRCPARAMS) {
	/* use: CountIcons <filename>
		 returns the number of icons the file has */
	char *FileName = data, FullName[MAX_PATH]; DWORD Result; UINT TotalIcons;

	Result = SearchPath(NULL, FileName, NULL, sizeof(FullName), FullName, NULL);
	if (Result == 0) { RetErr(ERR_FNF); }
	else if (Result > sizeof(FullName)) { RetErr(ERR_BIGPATH); }
	TotalIcons = ExtractIconEx(FullName, -1, NULL, NULL, 1);
	sprintf(data, "$true %u", TotalIcons);
	return MRV_RETURN;
}

/*
int __declspec(dllexport) __stdcall Editbox(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
	verCheck(MIRC_58);
	if (strlen(data) < 1) { RetErr(MUERR_INVPARAM); }
	char ldata[900], *num, *text; HWND hWnd = 0, hEdit; int selStart, selLen; long selEnd;
	strcpy(ldata, data); CharLower(ldata);
	if (!strncmp(ldata, "-w", 2)) {
		hWnd = (HWND)strtoul(&data[2], &data, 10);
		if (strncmp(data, " ", 1) == 0) { strcpy(data, &data[1]); }
		strcpy(ldata, data); CharLower(ldata);
	}
	if (hWnd == 0) { hWnd = aWnd; }
	hEdit = FindWindowEx(hWnd, NULL, "Edit", NULL);
	if (hEdit == 0) { RetErr(MUERR_INVWIN); }
	if (strlen(data)) {
		if (strncmp(ldata, "-p ", 3) == 0) { strcat(data, " "); strcpy(data, &data[3]); }
		if (strlen(data) < 1) { RetErr(MUERR_INVPARAM); }
		selStart = strtol(data, &num, 10) - 1;  //~ pra ficar com base 1
		if (selStart < 0) { selStart = 0; }
		if (strlen(num) < 2) { RetErr(MUERR_INVPARAM); }
		selLen = strtol(num, &text, 10);
		if (selLen < 0) { selLen = 0; }
		selEnd = selStart + selLen;
		if (strlen(text) > 1) {
			strcpy(text, &text[1]);
			SetWindowText(hEdit, text);
		}
		SendMessage(hEdit, EM_SETSEL, selStart, selEnd);
	}
	else { SetWindowText(hEdit, ""); }
	retOK;
}
*/

/*
MIRCDECLARE GetOSVersion(MIRCPARAMS) {
	OSVERSIONINFO VersionInfo; char WinVer[5];
	VersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&VersionInfo);
	switch (VersionInfo.dwPlatformId) {
		case VER_PLATFORM_WIN32s:
			strcpy(WinVer, "32s");
			break;
		case VER_PLATFORM_WIN32_WINDOWS:
			if (VersionInfo.dwMinorVersion > 0) {
				if (VersionInfo.dwMinorVersion >= 90) { strcpy(WinVer, "Me"); }
				else if ((VersionInfo.dwMinorVersion >= 10) && (VersionInfo.dwBuildNumber >= 2222)) { strcpy(WinVer, "98SE"); }
				else { strcpy(WinVer, "98"); }
			}
			else { strcpy(WinVer, "95"); }
			break;
		case VER_PLATFORM_WIN32_NT:
			if (VersionInfo.dwMajorVersion >= 5) {
				if (VersionInfo.dwMinorVersion >= 1) { strcpy(WinVer, "XP"); }
				else { strcpy(WinVer, "2000"); }
			}
			else { strcpy(WinVer, "NT"); }
			break;
	}
	sprintf(data, "Windows %s %lu.%02lu.%04u%s", WinVer, VersionInfo.dwMajorVersion, VersionInfo.dwMinorVersion,
		LOWORD(VersionInfo.dwBuildNumber), VersionInfo.szCSDVersion);
	return MRV_RETURN;
}
*/



MIRCDECLARE DLLInfo(MIRCPARAMS) {
	sprintf(data, "$true %s", DLLINFO);
	return MRV_RETURN;
}