// return values
#define MRV_HALT			0
#define MRV_CONTINUE	1
#define MRV_PERFORM		2
#define MRV_RETURN		3

// general constants & macros
#define MIRCDECLARE		int __declspec(dllexport) __stdcall
#define MIRCPARAMS		HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause
#define NUMBERS				"0123456789"
#define RetOK					strcpy(data, "$true"); return MRV_RETURN
#define RetErr(Err)		strcpy(data, "$false " Err); return MRV_RETURN
#define IsNumber(N)		strspn(N, NUMBERS) == strlen(N)

// error messages
#define ERR_INVPARAM	"invalid parameters"
#define ERR_FNF				"file not found"
#define ERR_BIGPATH		"file path is too big"
#define ERR_NOICON		"icon not found"
#define ERR_INVHWND		"invalid window"

// DllInfo constants
#define DLLVERSION  "1.2"
#define DLLINFO     "mIRCustom " DLLVERSION " for mIRC 5.8+  2001 Kamek - ircweb@hotmail.com"



// Structures
typedef struct {
  DWORD  mVersion;
  HWND   mHwnd;
  BOOL   mKeep;
} LOADINFO;

// Global variables
HINSTANCE hInstance;



BOOL WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, LPVOID lpvReserved);

HWND GetTargetWindow(char* data, HWND aWnd, HWND mWnd);

extern "C" {
  void __declspec(dllexport) __stdcall LoadDll(LOADINFO* lInfo);
  int __declspec(dllexport) __stdcall UnloadDll(int mTimeout);

  MIRCDECLARE Titlebar(MIRCPARAMS);
  MIRCDECLARE SetIcon(MIRCPARAMS);
  MIRCDECLARE CountIcons(MIRCPARAMS);

  //MIRCDECLARE GetOSVersion(MIRCPARAMS);

  MIRCDECLARE DLLInfo(MIRCPARAMS);
}
